package com.app;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

/**
 * @author Sarvesh Kumar
 * Provide update and download server in the application.
 */

@RestController
public class UploadController {
    private static final Logger logger = LoggerFactory.getLogger(UploadController.class);
    static StringBuilder data = new StringBuilder();

    public UploadController() {
    }

    @PostMapping({"/upload"})
    public void upload(@RequestParam MultipartFile file) {
        try {
            InputStream inputStream = file.getInputStream();
            BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));

            StringBuffer lines = new StringBuffer("");
            lines.append(bufferedReader.readLine());
            for(String line = bufferedReader.readLine(); line != null; line = bufferedReader.readLine()) {
                lines.append("\n"+line);
            }
            bufferedReader.close();

            logger.info("Data: {}", lines.toString());
            data.append(lines.toString());
        } catch (Exception ex) {
            logger.error(ex.getMessage());
        }

    }

    @GetMapping({"/data"})
    public String getData() {
        String result = data.toString();
        data = new StringBuilder();
        return result;
    }

}
